<?php
chdir("../../");
require_once("config.php");
require_once("firstin.php");
require_once("secure/secure.php");
require_once("include-sesvars.php");
require_once("htmlheader.php");
require_once("htmlfooter.php");

$separator         = addcslashes(setConfigDefault('csv_separator','',','),"'");
$csvquote          = addcslashes(setConfigDefault('csv_quote','','"'),"'");

$database = setConfigDefault('ivr_database','','asterisk');

$today = date('Y-m-d');

if(isset($_POST['daterange'])) {
    $partes = preg_split("/ - /",$_POST['daterange']);
    $start = $partes[0];
    $end   = $partes[1];
    $_SESSION['QSTATS']['start']=$start;
    $_SESSION['QSTATS']['end']=$end;
}

$ReportTitle="IVR Reports";
$partes = preg_split("/ /",$start);
$startd = $partes[0];
$partes = preg_split("/ /",$end);
$endd   = $partes[0];


include("datatable_translated.php");

$extra = "";

$extra.=$stabletranslated;





$extra.= "
<script>

var fieldBoundary='$csvquote';
var fieldSeparator='$separator';

\$(document).ready(function() {

\$('#daterange').daterangepicker(
{
   locale: {
      format: 'YYYY-MM-DD'
   },
   autoApply: true,
   startDate: '".$startd."',
   endDate: '".$endd."',
ranges: {
           '".trans('Today')."': [moment(), moment()],
           '".trans('Yesterday')."': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
           '".trans('Last 7 days')."': [moment().subtract(6, 'days'), moment()],
           '".trans('Last 30 days')."': [moment().subtract(29, 'days'), moment()],
           '".trans('This month')."': [moment().startOf('month'), moment().endOf('month')],
           '".trans('Last month')."': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
        },
alwaysShowCalendars: true,
showCustomRangeLabel: false,


}, function(start,end,label) {
    \$('#daterange').val(start.format('YYYY-MM-DD') + ' - ' + end.format('YYYY-MM-DD'));
    \$('#daterange').keyup();
    \$('form')[0].submit();
    //table.draw();

});
});
</script>
<script src='plugins/ivr/nested.tables.min.js'></script>
<style>
#reporttab_0 { width:100% !important; }
</style>
";

htmlHeader($extra);

include("menu.php");

echo "<div id='ivr_multiple_drilldown'>\n";
echo "<div class='row' >\n";  // twiter bootstrap grid
echo "<div class='col-md-12'>\n";  // twiter bootstrap grid


echo "<form method='post'>
<fieldset>
    <div class='row'>
        <div class='col-sm-4'>
            <div class='form-group'>
                <label class='col-md-3 control-label' style='padding-left:1px;' for='daterange'>".trans('Date').":</label>
                <div class='col-md-9'><input class='form-control datetime' id='daterange' name='daterange' size='30' type='text' value='$start'/></div>
            </div>
        </div>
    </div>
</fieldset>
</form>
";

$query = "SELECT distinct(flow) FROM $database.fop2_ivrflowlog WHERE datetime>='$start 00:00:00' AND datetime<='$end 23:59:59'";
$res = $db->consulta($query);

$total_data = array();
while($row=$db->fetch_assoc($res)) {

    $flow=$row['flow'];

    // query to get all call counts in this flow
    $query = "SELECT count(*) AS overflow,max(a.datetime) AS datetime,a.event,a.uniqueid,data AS callerid,";
    $query.= "IF(b.event LIKE 'COMPLETE%','1','0') AS handled_in_queue FROM $database.fop2_ivrflowlog a ";
    $query.= "LEFT JOIN qstats.queue_stats_mv b ON a.uniqueid=b.real_uniqueid WHERE a.event='ENTERFLOW' AND flow='$flow' AND a.datetime>='$start 00:00:00' AND a.datetime<='$end 23:59:59' GROUP BY uniqueid";

    $ras = $db->consulta($query);
    $count=0;
    $inqueue=0;
    while($rew=$db->fetch_assoc($ras)) {
        $count++;
        $inqueue+=intval($rew['handled_in_queue']);
    }
    $data = array ("data"=>array(trans("IVR FLow")=>$flow,trans("Calls")=>$count,trans("Answered in Queue")=>$inqueue));

    // query to get menu count for this flow
    $query = "select UNIX_TIMESTAMP(a.datetime) AS unix,a.datetime,a.menu,a.event,a.data,a.uniqueid,IF(b.event LIKE 'COMPLETE%','1','0') AS handled_in_queue ";
    $query.= "FROM $database.fop2_ivrflowlog a LEFT JOIN qstats.queue_stats_mv b ON a.uniqueid=b.real_uniqueid where flow='$flow' ";
    $query.= "AND a.event in ('SELECTION','INVALID','TIMEOUT','MENU')  AND a.datetime>='$start 00:00:00' AND a.datetime<='$end 23:59:59'";


    $ras = $db->consulta($query);
    $count=array();
    $inqueue=array();
    $invalid=array();
    $timeout=array();
    $menudata=array();
    $info2=array();
    $other = array(); // clear previous flows other options

    while($rew=$db->fetch_assoc($ras)) {
        if(!isset($count[$rew['menu']])) { $count[$rew['menu']]=0; }
        if(!isset($inqueue[$rew['menu']])) { $inqueue[$rew['menu']]=0; }
        if(!isset($invalid[$rew['menu']])) { $invalid[$rew['menu']]=0; }
        if(!isset($timeout[$rew['menu']])) { $timeout[$rew['menu']]=0; }
        if(!isset($total_selection_count[$rew['menu']])) { $total_selection_count[$rew['menu']]=0; }
        if(!isset($selections[$rew['menu']])) { $selection[$rew['menu']]=array(); }
        $count[$rew['menu']]++;

        $info2[$rew['menu']][]=array("data"=>array(
           "&nbsp;"=>"&nbsp;",
           _("Date")=>$rew['datetime'],
           _("Event")=>$rew['event'],
           _("Data")=>$rew['data'],
           _("Handled in Queue")=>$rew['handled_in_queue'],
           _("UniqueID")=>$rew['uniqueid']
        ), "kids"=>array());


        $inqueue[$rew['menu']]+=intval($rew['handled_in_queue']);
        $invalid[$rew['menu']]+=($rew['event']=='INVALID')?1:0;
        $timeout[$rew['menu']]+=($rew['event']=='TIMEOUT')?1:0;
        $total_selection_count[$rew['menu']]+=($rew['event']=='SELECTION')?1:0;
        $selection_key = ($rew['event']=='SELECTION')?$rew['data']:$rew['event'];
        if(!isset($selections[$rew['menu']][$selection_key])) { $selections[$rew['menu']][$selection_key]=0; }
        if(!isset($selections[$rew['menu']]['ABANDON'])) { $selections[$rew['menu']]['ABANDON']=0; }
        if($rew['event']!='MENU') {
            $selections[$rew['menu']][$selection_key]++;
            $selections[$rew['menu']]['ABANDON']--;
            $count[$rew['menu']]--;
        } else {
            $selections[$rew['menu']]['ABANDON']++;
        }
    }

    foreach($count as $key=>$value) {
        $info=array();
        foreach($selections[$key] as $selname=>$selcount) {
            if($selname!='MENU') {
                $info[]=array("data"=>array( trans("Selection")=>$selname,trans("Count")=>$selcount),"kids"=>array());
                if($selname=='ABANDON') { 
                   $abandon[$key] = $selcount;
                } else { 
                   if($selname!='INVALID' &&$selname!='TIMEOUT') {
                       $other[trans($selname)]=$selcount;
                   }
                }
            
            }
        }
        $extrainfo = array();
        $extrainfo[trans("Menu")]=$key;
        $extrainfo[trans("Count")]=$value;
        $extrainfo[trans("Answered in Queue")]=$inqueue[$key];
        $extrainfo[trans("Invalid")]=$invalid[$key];
        $extrainfo[trans("Timeout")]=$timeout[$key];
        $extrainfo[trans("Abandon")]=isset($abandon[$key])?$abandon[$key]:0;
        foreach($other as $kk=>$vv) {
           $extrainfo[$kk]=$vv;
        }
        $menudata[]=array( "data" => $extrainfo, "kids" => $info2[$key] );

    }

    $data['kids']=$menudata;

    $total_data[]=$data;

}

$data_json = json_encode($total_data);




if(isset($config['date_format'][''])) {

    $dfor = $config['date_format'][''];
    $sort="date_format(datetime,'$dfor') AS sort";

} else {

    $sort='datetime AS sort';
}


echo "<div id='report'></div>";


echo "<div id='ivrflow_detail'>\n";
echo "<hr class='soften'/>\n";
echo "<div class='row' >\n";  // twiter bootstrap grid
echo "<div class='col-md-12'>\n";  // twiter bootstrap grid

$query = "select uniqueid,$sort,unix_timestamp(datetime) as epoch,realflow,flow,menu,event,data from asterisk.fop2_ivrflowlog WHERE datetime>='$start 00:00:00' AND datetime<='$end 23:59:59' order by datetime,uniqueid,id";

$res = $db->consulta($query);
$uni='';
$cnt=0;
$line=array();
$rows=array("Date","UniqueID","CallerID","Flow","Duration");
$datarow=array();
while($row=$db->fetch_assoc($res)) {
    if($row['uniqueid']!=$uni) {  
        $callstart=$row['epoch'];  
        $datestart = $row['sort'];
        $flow = $row['flow']; 
        if($row['event']=='ENTERFLOW') { $clid=$row['data']; }
        if($cnt>0) {
           if($line['uniqueid']==$uni) {
               $datarow[]=$line;
           } else {
               $datarow[]=array("datetime"=>$datestart,  "uniqueid"=>$uni,  "clid"=>$clid, "flow"=>$flow, "duration"=>0);
           }
        }
    } else {
        if($row['event']=='ENTERFLOW') {
            $flow.=",".$row['flow'];
        }
        $now=$row['epoch']; 
        $delta = $now - $callstart;
        $sort = $row['sort'];
        $menu = $row['menu']; 
        $line = array("datetime"=>$datestart,  "uniqueid"=>$uni,  "clid"=>$clid, "flow"=>$flow, "duration"=>$delta);
    }
    $uni=$row['uniqueid'];
    $cnt++;
}
$datarow[]=$line;
$total_calls = count($datarow);
$top = head_report('HTML','IVR Call details',$rows,$total_calls);
echo $top;
$cnt=0;
foreach($datarow as $values) {
    $uniqueid = $values['uniqueid'];
    $uniuni = preg_replace("/[^a-zA-Z0-9]/","",$uniqueid);
    $uniunidrill = preg_replace("/[^a-zA-Z0-9]/","",$uniqueid);
    if(($cnt%2)>0) {
        $odd = "even";
    } else {
        $odd = "odd";
    }
    echo "<tr class='$odd'>";
    echo "<td>";
    echo "<a href='#' onclick='ajupdate(\"plugins/ivr/ajax-ivr-detail.php\",\"".$uniuni."\",\"uniqueid=$uniqueid\"); return false;' class='helptop' title='".trans('Click to view calls in detail')."'>";
    echo $values['datetime']."</a></td>";
    echo "<td>".$values['uniqueid']."</td>";
    echo "<td>".$values['clid']."</td>";
    echo "<td>".$values['flow']."</td>";
    echo "<td>".$values['duration']."</td>";
    echo "</tr>\n";
    echo "<tr id='$uniunidrill' style='display: none;'><td colspan='".count($rows)."'><span id='content$uniunidrill'>&nbsp;</span></td></tr>\n";
    $cnt++;

}

$footer = foot_report('HTML','Callback',$total_calls,0,0);
echo $footer;

echo "</div>";
echo "</div>";
echo "</div>";
echo "</div>";
echo "</div>";
echo "</div>";
echo "</div>";
echo "</div>";

$jsextra="
<script>
   var dataInJson = $data_json;


var settings = {
        iDisplayLength: 50,
        bLengthChange: false,
        bFilter: false,
        bSort: true,
        bInfo: true,
paging: false,
language: datatablelanguage,
buttons: [
            {
                extend:    'excelHtml5',
                text:      '<i class=\"fa fa-file-excel-o\"></i>',
                className: 'helpleft',
                titleAttr: 'Excel'
            },
            {
                extend:    'csvHtml5',
                text:      '<i class=\"fa fa-file-text-o\"></i>',
                className: 'helpleft',
                titleAttr: 'CSV'
            },
            {
                extend:    'pdfHtml5',
                text:      '<i class=\"fa fa-file-pdf-o\"></i>',
                className: 'helpleft',
                titleAttr: 'PDF'
            }
],
dom: \"<'row'<'col-sm-6'Bl><'col-sm-6'f>>\" + \"<'row'<'col-sm-12'tr>>\" + \"<'row'<'col-sm-5'><'col-sm-7'p>>\",
'columnDefs': [
    { width: '0px', 'targets': [ 0 ] }
  ]



      };
   table = new nestedTables.TableHierarchy(
        'report',
        dataInJson,
        settings
      );
      table.initializeTableHierarchy();

$('#reporttab_0').append('<caption><h3>"._('IVR Summary')."</h3></caption>');
</script>
";

htmlFooter($jsextra);

